//NL_QL_USR serial to QL
//
// Board = ESP32 DEV Module
#include <WiFi.h>
#include "time.h"
#include "sntp.h"
#include <HTTPClient.h>
HTTPClient http;      // http client init

#include <TFT_eSPI.h> // Hardware-specific library
TFT_eSPI tft = TFT_eSPI();    //choose 25 in \libraries\tft_espi\User_Setup_Select.h 
                              //and user_setup.h #define ST7789_DRIVER 

#include "var.h"
#include "weather.h"
#include "multi.h"

#define RXD2 15   // Serial to ttl
#define TXD2 2    //

void printLocalTime()
{
  struct tm timeinfo;
  if(!getLocalTime(&timeinfo)){
    Serial.println("No time available (yet)");
    return;
  }
 // Serial.println(&timeinfo, "%A, %B %d %Y %H:%M:%S");
  tft.drawString((&timeinfo, "%Y %M %d %H %M"),112,30,1);
  yy=timeinfo.tm_year+1900;  //year = year since 1900
  mo=timeinfo.tm_mon+1;      //month = from 0 so +1
  dd=timeinfo.tm_mday;
  hh=timeinfo.tm_hour;
  mn=timeinfo.tm_min;
  sec=timeinfo.tm_sec;
}

// Callback function (get's called when time adjusts via NTP)
void timeavailable(struct timeval *t){
  Serial.println("Got time adjustment from NTP!");
  printLocalTime();
}

void start_wifi(){
 Serial.printf("Connecting to %s ", ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
  }
  Serial.println(" CONNECTED");
}
void snd_ql(){
  Serial2.print(yy);Serial2.printf("%02d",mo);Serial2.printf("%02d",dd);Serial2.printf("%02d",hh);
  Serial2.printf("%02d",mn);Serial2.printf("%02d",sec);Serial2.println("");
}


void setup(){
 pinMode(0, INPUT_PULLDOWN);
 pinMode(35, INPUT_PULLDOWN);
 tft.init();tft.setRotation(1);
  tft.fillScreen(TFT_BLACK);
  //tft.fillScreen(TFT_GREY);
  
  tft.setTextColor(TFT_WHITE, TFT_BLACK);  // Adding a background colour erases previous text automatically

  Serial.begin(115200);
  Serial.println(__FILE__);
  Serial.print("QL Serial NL_QL_USR: \t");
  Serial.println("0.01");
  
 // set notification call-back function
  sntp_set_time_sync_notification_cb( timeavailable );
  configTzTime(time_zone, ntpServer1, ntpServer2);

  start_wifi();

  help(); hlp_ql();

 Serial2.begin(19200, SERIAL_8N1, RXD2, TXD2);

}

//-------------------------------------------------------
void loop(){
  if (Serial.available() > 0){
    int c = Serial.read();
    switch (c)
    {
      case '?' :
        help();hlp_ql();
        break;
      case 'd' :
        //tft.println("20240312");
        tft.println("");
        printLocalTime();
        Serial2.println("serial2test");
        snd_ql();
      break;
      case 'w' :
         wttr();
        break;
      case 'q' :
        //tft.("Hello (QL) world");
        Serial.println("Hello (QL) World");
        Serial2.write("Hello (QL) World/n/n");
      break;
   } 
  }
  if (Serial2.available()>0){
    char q = Serial2.read();
    switch (q)
    {
      case '?':
       help();
      break;
      case 'd':
       printLocalTime();
       snd_ql();
      break;
      case 'q':
       Serial2.println("Hello QL");
      break;
      case 'w':
       wttr();
      break;
    }
  }

}//end loop

